# Bryan Schumaker (8/13/2010)

import gtk
import gobject
import pango
import libsaria

gdk = gtk.gdk

__major__ = 4
__minor__ = 1
__bug__   = 2
__dev__   = False

__vers__  = "Ocarina %s.%s" % (__major__, __minor__)
if __bug__ > 0:
	__vers__ = "%s.%s" % (__vers__, __bug__)
if __dev__ == True:
	__vers__ += "-dev"

gdk.threads_init()
gobject.threads_init()

# Lazy loaded modules
window = None
tabs   = None
box    = None


# Function override variables
get_tabs   = None
get_window = None


# Global variables for some objects
#main_window = None
#main_tabs   = None

def startup():
	global gtk
	import gtk
	libsaria.startup()
	gtk.main()

def exit(widget, event):
	gtk.main_quit()
	libsaria.shutdown()


def get_tabs_once():
	global tabs
	global get_tabs
	import tabs
	tabs.init()
	get_tabs = get_tabs_rest
	return tabs.tabs
def get_tabs_rest():
	global tabs
	return tabs.tabs
get_tabs = get_tabs_once

def add_tab(text, content):
	global tabs
	tabs.append_page(content, text)

def remove_tab(text):
	global tabs
	tabs.remove_page(text)


def get_window_once(size):
	global window
	global get_window
	import window
	window.init(size)
	window.add(get_tabs())
	get_window = get_window_rest
	return window.window
def get_window_rest(size=None):
	global window
	if size != None:
		window.resize(size[0], size[1])
	return window.window
get_window = get_window_once

def set_window_title(text):
	window = get_window()
	window.set_title(text)

def set_window_icon(path):
	if libsaria.path.exists(path):
		window = get_window()
		window.set_icon_from_file(path)
